Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions

# NodeCachedReferenceCount Class Reference

This class further specializes CachedTypedWritableReferenceCount to also add a node_ref_count, for the purposes of counting the number of times the object is referenced by a "node", presumably a PandaNode. More...

Inheritance diagram for NodeCachedReferenceCount:

List of all members.

## Public Types
enum | Referenced { RNode = 1, RCache = 2 }
## Public Member Functions
int | getNodeRefCount ()
| Returns the current reference count.
int | getReferencedBits ()
| Returns the union of the values defined in the Referenced enum that represents the various things that appear to be holding a pointer to this object.
| nodeRef ()
| Explicitly increments the reference count.
bool | nodeUnref ()
| Explicitly decrements the node reference count and the normal reference count simultaneously.
bool | testRefCountIntegrity ()
| Does some easy checks to make sure that the reference count isn't completely bogus.
## Static Public Member Functions
static TypeHandle | getClassType ()

## Detailed Description

This class further specializes CachedTypedWritableReferenceCount to also add a node_ref_count, for the purposes of counting the number of times the object is referenced by a "node", presumably a PandaNode.

This essentially combines the functionality of NodeReferenceCount and CachedTypedWritableReferenceCount, so that a derivative of this object actually has three counters: the standard reference count, the "cache" reference count, and the "node" reference count. Rather than multiply inheriting from the two reference count classes, we inherit only from CachedTypedWritableReferenceCount and simply duplicate the functionality of NodeReferenceCount, to avoid all of the problems associated with multiple inheritance.

The intended design is to use this as a base class for RenderState and TransformState, both of which are held by PandaNodes, and also have caches which are independently maintained. By keeping track of how many nodes hold a pointer to a particular object, we can classify each object into node-referenced, cache-referenced, or other, which is primarily useful for PStats reporting.

As with CachedTypedWritableReferenceCount's cache_ref() and cache_unref(), the new methods node_ref() and node_unref() automatically increment and decrement the primary reference count as well. In this case, however, there does exist a NodePointerTo<> class to maintain the node_ref counters automatically.

## Member Enumeration Documentation

enum Referenced

Enumerator:

  RNode |
  RCache |

## Member Function Documentation

static TypeHandle getClassType | ( |  | ) | `[static]`

Reimplemented from CachedTypedWritableReferenceCount.

Reimplemented in TransformState, and RenderState.

int getNodeRefCount | ( |  | ) |

Returns the current reference count.

int getReferencedBits | ( |  | ) |

Returns the union of the values defined in the Referenced enum that represents the various things that appear to be holding a pointer to this object.

If R_node is included, at least one node is holding a pointer; if R_cache is included, at least one cache element is.

nodeRef | ( |  | ) |

Explicitly increments the reference count.

This function is const, even though it changes the object, because generally fiddling with an object's reference count isn't considered part of fiddling with the object. An object might be const in other ways, but we still need to accurately count the number of references to it.

Reimplemented in TransformState, and RenderState.

bool nodeUnref | ( |  | ) |

Explicitly decrements the node reference count and the normal reference count simultaneously.

The return value is true if the new reference count is nonzero, false if it is zero.

Reimplemented in TransformState, and RenderState.

bool testRefCountIntegrity | ( |  | ) |

Does some easy checks to make sure that the reference count isn't completely bogus.

Reimplemented from CachedTypedWritableReferenceCount.

All Classes Namespaces Functions Variables Enumerations Enumerator Properties